﻿//Created by Struggle-luan
//Thanks for using~

using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Collections.Generic;
using System.Windows.Media.Imaging;

namespace Silverlight_ImageLoader
{
    public class ImageLoader
    {
        //FDS:
        private int ID_Count;
        public int TaskCount { get { return ID_Count; } }
        private double C_Progress;
        public double TaskProgress { get { return C_Progress / ID_Count; } }
        private List<ImageData> OperatingData;
        private Grid G_Temp;
        private Panel Container;
        private Dictionary<BitmapImage,int> ProgressCounter;
        private bool AvoidDoubleFinishes = false;

        //DELES:
        public delegate void D_ProgressChanged(ImageLoader Sender, double Progress);
        public delegate void D_TaskAllFinished(ImageLoader Sender,List<Image> DataOutPut);

        //PUB_EVENTS:
        public event D_ProgressChanged ProgressChanged;
        public event D_TaskAllFinished TaskFinished;

        //P_FUNCT"
        public void LoadImages(List<ImageData> RequestDataList,Panel VisibleContainer)
        {
            AvoidDoubleFinishes = false;
            ProgressCounter = new Dictionary<BitmapImage,int>();
            Container = VisibleContainer;
            OperatingData = RequestDataList;
            C_Progress = 0;
            ID_Count = RequestDataList.Count;
            G_Temp = new Grid();
            G_Temp.Height = 0;
            G_Temp.Width = 0;
            foreach (ImageData ID in OperatingData)
            {
                BitmapImage BI = new BitmapImage();
                ProgressCounter.Add(BI, 0);
                BI.DownloadProgress += new EventHandler<DownloadProgressEventArgs>(BI_DownloadProgress);
                BI.UriSource = ID.TargetURI;
                ID.TargetImagePointer.Source = BI;
                G_Temp.Children.Add(ID.TargetImagePointer);
            }
            Container.Children.Add(G_Temp);
        }

        //INNER_EVENTS:
        void BI_DownloadProgress(object sender, DownloadProgressEventArgs e)
        {
            ProgressCounter[sender as BitmapImage] = e.Progress;
            int Temp = 0;
            foreach (int i in ProgressCounter.Values)
            {
                Temp += i;
            }
            C_Progress = Temp;
            if (TaskProgress == 100 && (!AvoidDoubleFinishes))
            {
                List<Image> Ready = new List<Image>();
                foreach (ImageData ID in OperatingData)
                {
                    G_Temp.Children.Remove(ID.TargetImagePointer);
                    Ready.Add(ID.TargetImagePointer);
                }
                TaskFinished.Invoke(this,Ready);
                AvoidDoubleFinishes = true;
                Container.Children.Remove(G_Temp);
            }
            else
            {
                ProgressChanged.Invoke(this,TaskProgress);
            }
        }

    }


    public class ImageData
    {
        public Uri TargetURI { get; set; }
        public Image TargetImagePointer { get; set; }
    }
}
